(* @LICENSE@ *)
program PublisherTool;

{$APPTYPE CONSOLE}

uses
  btHabariXBExpress,
  JclSysInfo,
  BTLog,
  SysUtils;

const
  NUM_MESSAGES = 1000000;

var
  I: Integer;

begin
{$WARN SYMBOL_PLATFORM OFF}
  ReportMemoryLeaksOnShutDown := DebugHook<>0;
{$WARN SYMBOL_PLATFORM ON}

  with THabariXBExpress.Create(nil) do
  try
    // Logger.LogLevel := logTrace;
    Host := JclSysInfo.GetIPAddress(GetLocalComputerName);
    OptionsConnect.UserName := 'SimpleReader';
    OptionsConnect.PassWord := 'secret';
    OptionsConnect.SessionName := 'PublisherTool';
    OptionsPublish.DestinationName := 'PublisherToolTopic';
    Connect;
    for I := 0 to NUM_MESSAGES - 1 do
    begin
      if ((I+1) mod 100) = 0 then
      begin
        WriteLn(Format('Message %d', [I + 1]));
      end;
      // send the message
      try
        Publish(Format('Message %d', [I + 1]));
      except
        on E: Exception do
        begin
          WriteLn('Exception: ' + E.Message);
        end;
      end;
    end;
    Disconnect;
  finally
    Free;
  end;
  WriteLn('Press any key');
  ReadLn;
end.

