(* @LICENSE@ *)
program SubscriberTool;

{$APPTYPE CONSOLE}

uses
  btHabariXBExpress,
  xbQosInterfaces,
  xbQosTypes,
  BTLog,
  JclSysInfo,
  SysUtils;

const
  NUM_MESSAGES = 1000;

var
  SubscribeKey: ISubscribeKey;
  SubscribeQos: ISubscribeQos;

type
  THabariExpressSubscribeDemo = class(THabariXBExpress)
  private
    procedure MyOnUpdate(const SessionID, Key, Content, Qos: string);
  end;

{ THabariExpressSubscribeDemo }

procedure THabariExpressSubscribeDemo.MyOnUpdate(const SessionID, Key, Content,
  Qos: string);
begin
  Logger.Info(Content);
end;

begin
{$WARN SYMBOL_PLATFORM OFF}
  ReportMemoryLeaksOnShutDown := DebugHook<>0;
{$WARN SYMBOL_PLATFORM ON}

  with THabariExpressSubscribeDemo.Create(nil) do
  try
    // Logger.LogLevel := logTrace;
    Host := JclSysInfo.GetIPAddress(GetLocalComputerName);
    OptionsConnect.UserName := 'SimpleReader';
    OptionsConnect.PassWord := 'secret';
    OptionsConnect.SessionName := 'SubscriberTool';
    OnUpdate := MyOnUpdate;
    Connect;
    SubscribeKey := TSubscribeKey.Create;
    SubscribeKey.Oid := 'PublisherToolTopic';
    SubscribeQos := TSubscribeQos.Create;
    Subscribe(SubscribeKey, SubscribeQos);
    Sleep(10000);
    Disconnect;
  finally
    Free;
  end;
  WriteLn('Press any key');
  ReadLn;
end.


